package org.example;

import com.alibaba.fastjson.JSON;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;

import java.sql.*;
import java.util.List;
import java.util.Map;

public class CsvCalciteDemo {
    public static void main(String[] args) {
        try {
            String model = "{\n" +
                    "  \"version\": \"1.0\",\n" +
                    "  \"defaultSchema\": \"CSV_DB\",\n" +
                    "  \"schemas\": [\n" +
                    "    {\n" +
                    "      \"name\": \"CSV_DB\",\n" +
                    "      \"type\": \"custom\",\n" +
                    "      \"factory\": \"org.example.csv.CsvSchemaFactory\",\n" +
                    "      \"operand\": {\n" +
                    "        \"dataFile\": \"RECORD.csv\"\n" +
                    "      }\n" +
                    "    }\n" +
                    "  ]\n" +
                    "}";
            Connection connection = DriverManager.getConnection("jdbc:calcite:model=inline:" + model);

            Statement statement = connection.createStatement();

            ResultSet resultSet = statement.executeQuery("select * from csv_db.record");
            System.out.println(JSON.toJSONString(getData(resultSet)));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static List<Map<String,Object>> getData(ResultSet resultSet)throws Exception{
        List<Map<String,Object>> list = Lists.newArrayList();
        ResultSetMetaData metaData = resultSet.getMetaData();
        int columnSize = metaData.getColumnCount();

        while (resultSet.next()) {
            Map<String, Object> map = Maps.newLinkedHashMap();
            for (int i = 1; i < columnSize + 1; i++) {
                map.put(metaData.getColumnLabel(i), resultSet.getObject(i));
            }
            list.add(map);
        }
        return list;
    }
}
